# -*- encoding: utf-8 -*-

__Autor__ = "Luiz Fernando"
__Empresa__ = "Sig Informatica Ltda"
__Site__ = "http://www.siginformatica.com.br"
__Versao__ = "1.01"
__DataAlteracao__ = "31/07/2013"
__lista_pk = 'x\x9c\x0b\xceLw\r\n\xd0\r\xce,.I\xcdMT\xf0\xcc+I\xcd\xc9LO\x05R\n)\xa9\n\xee\xa9\xc5%\x89\xf9\x8a\x00\xfb:\r3'

import zlib

from openerp import pooler

from SigUtils import crypto
from SigUtils import datas


def _crypto_sig(encripta_decripta, dados):
    _pk = zlib.decompress(__lista_pk)
    if encripta_decripta.lower() == 'e':
        return crypto.encrypt(dados, _pk)
    if encripta_decripta.lower() == 'd':
        return crypto.decrypt(dados, _pk)
    return False


def _get_licensa_sig_erp(self, cr, uid):
    """
    Função para verificar a licensa do SigERP
    Retorna:
        - False quando não tem licensa ou
        - dicionario com dias para vencer, qtd empresas, qtd usuarios, lista de modulos
    """
    def _ativar_pedido_de_validacao(self, cr, uid):
        objCron = pooler.get_pool(cr.dbname).get('ir.cron')
        cr.execute("select id from ir_cron where name ='Validar o sistema'")
        res = cr.dictfetchone()
        id = False
        if res:
            id = res['id']
        ids = [id]
        vals = {
            'numbercall': 1,
            'active': True,
        }
        try: # Qdo o cron está em execução, não é possivel alterá-lo
            objCron.write(cr, uid, ids, vals)
        except:
            pass
        return True

    cr.execute("select * from ir_module_module where name = 'adm' and state = 'installed'")
    dados = cr.dictfetchone()
    if not dados:
        return True
    licensa = self.pool.get('ir.config_parameter').get_param(cr, uid, 'licensa_sig_erp')
    cr.execute('select cpf_cnpj from adm_pessoa where id = 2')
    dados = cr.dictfetchone()
    _cnpj = str(dados['cpf_cnpj']).replace('.', '').replace('-', '').replace('/', '')
    if not licensa or licensa == '12345':
        _ativar_pedido_de_validacao(self, cr, uid)
        return False
    dados_licensa = _crypto_sig('d', licensa).split(';')
    if _cnpj != dados_licensa(0) or '00000000' == dados_licensa(1):
        _ativar_pedido_de_validacao(self, cr, uid)
        return False
    dias = datas.calcDiferenca(datas.getDataDeHoje(), dados_licensa(1))
    if dias < 1:
        _ativar_pedido_de_validacao(self, cr, uid)
    if dias < -10:
        return False
    return {
        'dias': dias,
        'empresas': dados_licensa(2),
        'usuarios': dados_licensa(3),
        'modulos': dados_licensa(4)
    }

def search(self, cr, user, args, offset=0, limit=None, order=None, context=None, count=False):
    #Quando houver no contexto "sig_force_company", não será feito nenhum tratamento no args
    if not context:
        context = {}
    # liberar apartir da versao 4A
    # if not context.get('install_mode'):
    #     if not (self._name.startswith('ir.') or
    #             self._name.startswith('res.') or
    #             self._name.startswith('base.') or
    #             self._name.startswith('adm.monitor.')):
    #         if not _get_licensa_sig_erp(self, cr, user):
    #             limit = 5
    if context.get('sig_force_company') and context.get('sig_force_company') == True:
        return args, offset, limit, order, context, count
    if 'parametro' in self._name and not self._name == 'financeiro.parametros.cobranca':
        if not self._columns.has_key('company_id'):
            return args, offset, limit, order, context, count

        if 'all' in args:
            args = []
        else:
            # tem que passar o company_id caso o cron esteja executando a importacao de cupom,
            # no caso de multi-empresa para nao pegar o parametro de outra empresa.
            arg_company = filter(lambda x: x[0] == 'company_ids', args)
            user_company_id = arg_company and arg_company[0][2] or False
            company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, user, self._name,
                                                   context=context, user_company_id=user_company_id)
            args = [('company_id', '=', company_id)]
    else:
        company_id = _ajustar_empresa(self, cr, user, False, context)
        if company_id:
            args_temp = filter(lambda i: 'company_id' not in i, args)
            #Qdo no contexto tiver "sig_search_sem_filhos", não será feito tratamento para empresas filhas
            if not context.get('sig_search_sem_filhos'):
                company_ids = list(set(self.pool.get('res.company')._get_company_children(
                    cr, user, company_id)))
                if company_ids:
                    company_ids.append(company_id)
                    args_temp.append(('company_id', 'in', list(set(company_ids))))
                else:
                    args_temp.append(('company_id', '=', company_id))

            else:
                args_temp.append(('company_id', '=', company_id))
            args = args_temp
    #     tabelas = ['adm.empresa.objeto', 'legado.empresa', 'ir.values', 'res.company', 'res.users', 'ir.sequence']
    #     if not self._name in tabelas and self._columns.has_key('company_id'):
    #         company_id = False
    #         args_temp = filter(lambda i: 'company_id' not in i, args)
    #         obj_adm_empresa = self.pool.get('adm.empresa.objeto')
    #         if obj_adm_empresa:
    #             company_id = obj_adm_empresa.getEmpresa(cr, user, self._name)
    #         if company_id:
    #             #Qdo no contexto tiver "sig_search_sem_filhos", não será feito tratamento para empresas filhas
    #             if not context.get('sig_search_sem_filhos'):
    #                 company_ids = list(set(self.pool.get('res.company')._get_company_children(
    #                     cr, user, company_id)))
    #                 if company_ids:
    #                     company_ids.append(company_id)
    #                     args_temp.append(('company_id', 'in', list(set(company_ids))))
    #                 else:
    #                     args_temp.append(('company_id', '=', company_id))
    #
    #             else:
    #                 args_temp.append(('company_id', '=', company_id))
    #             args = args_temp
    # #
    return args, offset, limit, order, context, count

def name_search(self, cr, user, name='', args=None, operator='ilike', context=None, limit=100):
    #Quando houver no contexto "sig_force_company", não será feito nenhum tratamento no args
    if not context:
        context = {}

    if context.get('sig_force_company'):
        return name, args, operator, context, limit

    if 'parametro' in self._name and not self._name == 'financeiro.parametros.cobranca':
        if not self._columns.has_key('company_id'):
            return name, args, operator, context, limit

        if 'all' in args:
            args = []
        else:
            # tem que passar o company_id caso o cron esteja executando a importacao de cupom,
            # no caso de multi-empresa para nao pegar o parametro de outra empresa.
            arg_company = filter(lambda x: x[0] == 'company_ids', args)
            user_company_id = arg_company and arg_company[0][2] or False
            company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, user, self._name,
                                                   context=context, user_company_id=user_company_id)
            args = [('company_id', '=', company_id)]
    else:
        company_id = _ajustar_empresa(self, cr, user, False, context)
        if company_id:
            args_temp = filter(lambda i: 'company_id' not in i, args)
            #Qdo no contexto tiver "sig_search_sem_filhos", não será feito tratamento para empresas filhas
            if not context.get('sig_search_sem_filhos'):
                company_ids = list(set(self.pool.get('res.company')._get_company_children(
                    cr, user, company_id)))
                if company_ids and company_id not in company_ids:
                    company_ids.append(company_id)
                    args_temp.append(('company_id', 'in', list(set(company_ids))))
                else:
                    args_temp.append(('company_id', '=', company_id))
            else:
                args_temp.append(('company_id', '=', company_id))
            args = args_temp
    #
    #     tabelas = ['adm.empresa.objeto', 'legado.empresa', 'ir.values', 'res.company', 'res.users', 'ir.sequence']
    #     if not self._name in tabelas and self._columns.has_key('company_id'):
    #         company_id = False
    #         args_temp = filter(lambda i: 'company_id' not in i, args)
    #         obj_adm_empresa = self.pool.get('adm.empresa.objeto')
    #         if obj_adm_empresa:
    #             company_id = obj_adm_empresa.getEmpresa(cr, user, self._name)
    #         if company_id:
    #             #Qdo no contexto tiver "sig_search_sem_filhos", não será feito tratamento para empresas filhas
    #             if not context.get('sig_search_sem_filhos'):
    #                 company_ids = list(set(self.pool.get('res.company')._get_company_children(
    #                     cr, user, company_id)))
    #                 if company_ids and company_id not in company_ids:
    #                     company_ids.append(company_id)
    #                     args_temp.append(('company_id', 'in', list(set(company_ids))))
    #                 else:
    #                     args_temp.append(('company_id', '=', company_id))
    #
    #             else:
    #                 args_temp.append(('company_id', '=', company_id))
    #             args = args_temp
    # #
    return name, args, operator, context, limit


def _ajustar_empresa(self, cr, uid, company_id, context):
    _spg = self.pool.get
    tabelas = ['adm.empresa.objeto', 'legado.empresa', 'ir.values','res.company', 'res.users', 'ir.sequence']
    try:
        if self._name in tabelas or not self._columns.has_key('company_id'):
            return company_id
        if not context.get('sig_force_company', False):
            return _spg('adm.empresa.objeto').getEmpresa(cr, uid, self._name)
        emp = context.get('sig_force_company')
        if isinstance(emp, bool):
            return company_id
        return _spg('adm.empresa.objeto').getEmpresa(cr, uid, self._name, user_company_id=emp)
    except:
        pass
    return company_id

def _ajustar_vals(self, cr, uid, vals, context):
    if isinstance(vals, dict):
        if vals.has_key('write_date'):
            vals.pop('write_date')
        if vals.has_key('write_uid'):
            vals.pop('write_uid')
    company_id = _ajustar_empresa(self, cr, uid, vals.get('company_id', False), context)
    if company_id:
        vals['company_id'] = company_id
    return vals

def write(self, cr, uid, ids, vals, context=None):
    if context is None:
        context = {}
    if 'company_id' in vals: # NO write só ajustar se veio empresa no vals
        return _ajustar_vals(self, cr, uid, vals, context)
    return vals

def create(self, cr, uid, vals, context=None):
    if context is None:
        context = {}
    return _ajustar_vals(self, cr, uid, vals, context)

def _get_sig_server(servidor):
    return _crypto_sig('d', servidor)

def _set_sig_server(host, bd, porta, user, passwd):
    if not host:
        host = 'erp.siginformatica.com.br'
    if not bd:
        bd = 'erp'
    if not porta:
        porta = '8069'
    if not user:
        user = 'remoto'
    if not passwd:
        passwd = 'remo102938'
    lista = str(host) + ',' + str(bd) + ',' + str(porta) + ',' + str(user) + ',' + str(passwd)
    return _crypto_sig('e', lista)

