# -*- coding: iso-8859-1 -*-

__Autor__ = "Luiz Fernando"
__Empresa__ = "Sig Informatica Ltda"
__Site__ = "http://www.siginformatica.com.br"
__Versao__ = "1.03"
__DataAlteracao__ = "24/10/2008"
import sys
if __name__ == '__main__':
    try:
        if sys.argv[1] == '-9':
            print('uf.py\t\t\tVersao:' + __Versao__ + '\tData:'+ __DataAlteracao__) + '\tTratamento de estados do Brasil'
        else:
           print('\n\nuf.py - Tratamento de estados do Brasil \n'
                   +'Versao: '+ __Versao__ + '\n'
                   +'Data: '+ __DataAlteracao__ + '\n')
    except:
       print('\n\nuf.py - Tratamento de estados do Brasil \n'
               +'Versao: '+ __Versao__ + '\n'
               +'Data: '+ __DataAlteracao__ + '\n')



import string
class Uf(object):
   """ classe para tratar UF
       Valida os estados da federacao
       retorna descricao do estado da federacao
       retorna lista de siglas de estado
       Qdo houver erro, retorna False
                        """
     
   def __iniciaVariaveis(self):
       self.uf=''
       self.UFs = {'RS':'Rio Grande Do Sul',  \
               'SC':'Santa Catarina',     \
               'PR':'Parana',             \
               'SP':'Sao Paulo',          \
               'RJ':'Rio de Janeiro',     \
               'MG':'Minas Gerais',       \
               'ES':'Espirito Santo',     \
               'BA':'Bahia',              \
               'SE':'Sergipe',            \
               'PB':'Paraiba',            \
               'PE':'Pernambuco',         \
               'AL':'Alagoas',            \
               'RN':'Rio Grande do Norte',\
               'CE':'Ceara',              \
               'PI':'Piaui',              \
               'MA':'Maranhao',           \
               'MS':'Mato Grosso do Sul', \
               'MT':'Mato Grosso',        \
               'GO':'Goias',              \
               'DF':'Distrito Federal',   \
               'TO':'Tocantins',          \
               'RR':'Roraima',            \
               'RO':'Rondonia',           \
               'PA':'Para',               \
               'PB':'Paraiba',            \
               'AM':'Amazonas',           \
               'AP':'Amapa',              \
               'AC':'Acre'}
                 

   def __init__(self, estado=''):
       self.__iniciaVariaveis()
       self.uf=string.upper(estado)

   def validaEstado(self):
       """Retorno    False = estado invalido, True = Estado Ok
                                    """
       try:
          descricao=self.UFs[self.uf]
       except:
          return False
       return True
   
   def getDescricao(self):
       """Retorna a descricao do estado da federaca
                           """
       try:
          descricao=self.UFs[self.uf]
       except:
          return False
       return descricao
       
def getListaUf():
    """Retorna a lista das UFs cadastradas
                  """       
    a=Uf('')
    return a.UFs.keys()


 

